Halide 22.0.0 Halide compiler and libraries

Loading...
Searching...
No Matches
Classes | Public Member Functions | Public Attributes | Static Public Attributes | List of all members
Halide::Internal::IRMatcher::IntLiteral Struct Reference

`#include <IRMatch.h>`

## Classes
struct | pattern_tag

## Public Member Functions
HALIDE_ALWAYS_INLINE | IntLiteral (int64_t v)
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const BaseExprNode &e, MatcherState &state) const noexcept
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (int64_t val, MatcherState &state) const noexcept
template<uint32_t bound>
HALIDE_ALWAYS_INLINE bool | match (const IntLiteral &b, MatcherState &state) const noexcept
HALIDE_ALWAYS_INLINE Expr | make (MatcherState &state, halide_type_t type_hint) const
HALIDE_ALWAYS_INLINE void | make_folded_const (halide_scalar_value_t &val, halide_type_t &ty, MatcherState &state) const noexcept

## Public Attributes
int64_t | v

## Static Public Attributes
static constexpr uint32_t | binds = 0
static constexpr IRNodeType | min_node_type = IRNodeType::IntImm
static constexpr IRNodeType | max_node_type = IRNodeType::FloatImm
static constexpr bool | canonical = true
static constexpr bool | foldable = true

## Detailed Description

Definition at line 488 of file IRMatch.h.

## Constructor & Destructor Documentation

## ◆ IntLiteral()

HALIDE_ALWAYS_INLINE Halide::Internal::IRMatcher::IntLiteral::IntLiteral | ( | int64_t | v | ) |
| inline explicit

Definition at line 499 of file IRMatch.h.

## Member Function Documentation

## ◆ match() [1/3]

template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::IntLiteral::match | ( | const BaseExprNode & | e,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 504 of file IRMatch.h.

References Halide::Internal::Broadcast, Halide::Internal::FloatImm, Halide::Internal::IntImm, Halide::Internal::IRNode::node_type, Halide::Internal::UIntImm, and v.

## ◆ match() [2/3]

template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::IntLiteral::match | ( | int64_t | val,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 522 of file IRMatch.h.

References v.

## ◆ match() [3/3]

template<uint32_t bound>

HALIDE_ALWAYS_INLINE bool Halide::Internal::IRMatcher::IntLiteral::match | ( | const IntLiteral & | b,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 527 of file IRMatch.h.

References v.

## ◆ make()

HALIDE_ALWAYS_INLINE Expr Halide::Internal::IRMatcher::IntLiteral::make | ( | MatcherState & | state,
|  | halide_type_t | type_hint
| ) |  | const
| inline

Definition at line 532 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast(), Halide::Internal::make_const(), and v.

## ◆ make_folded_const()

HALIDE_ALWAYS_INLINE void Halide::Internal::IRMatcher::IntLiteral::make_folded_const | ( | halide_scalar_value_t & | val,
|  | halide_type_t & | ty,
|  | MatcherState & | state
| ) |  | const
| inline noexcept

Definition at line 539 of file IRMatch.h.

References Halide::Internal::IRMatcher::cast(), halide_type_bfloat, halide_type_float, halide_type_int, halide_type_uint, and v.

## Member Data Documentation

## ◆ v

int64_t Halide::Internal::IRMatcher::IntLiteral::v

Definition at line 490 of file IRMatch.h.

Referenced by make(), make_folded_const(), match(), match(), match(), Halide::Internal::IRMatcher::operator<<(), and Halide::Internal::IRMatcher::unwrap().

## ◆ binds

constexpr uint32_t Halide::Internal::IRMatcher::IntLiteral::binds = 0
| static constexpr

Definition at line 492 of file IRMatch.h.

## ◆ min_node_type

constexpr IRNodeType Halide::Internal::IRMatcher::IntLiteral::min_node_type = IRNodeType::IntImm
| static constexpr

Definition at line 494 of file IRMatch.h.

## ◆ max_node_type

constexpr IRNodeType Halide::Internal::IRMatcher::IntLiteral::max_node_type = IRNodeType::FloatImm
| static constexpr

Definition at line 495 of file IRMatch.h.

## ◆ canonical

constexpr bool Halide::Internal::IRMatcher::IntLiteral::canonical = true
| static constexpr

Definition at line 496 of file IRMatch.h.

## ◆ foldable

constexpr bool Halide::Internal::IRMatcher::IntLiteral::foldable = true
| static constexpr

Definition at line 536 of file IRMatch.h.

The documentation for this struct was generated from the following file:

- src/IRMatch.h